package EDU.auburn.VGJ.gui;

//import webflow.appletsocket.*;
import webflow.frontend.ModuleControls.*;

import com.sun.java.swing.*;
import com.sun.java.swing.JTree;
import com.sun.java.swing.tree.DefaultMutableTreeNode;
import com.sun.java.swing.JScrollPane;
import com.sun.java.swing.JPanel;
import com.sun.java.swing.JFrame;
import java.awt.GridLayout;
import java.awt.event.WindowListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.Enumeration;
import java.awt.*;
import java.awt.event.*;
import java.lang.*;
import java.util.*;
import java.io.*;
import java.net.*;

import com.sun.java.swing.JLabel;
import com.sun.java.swing.JTextField;
import com.sun.java.swing.event.*;
import com.sun.java.swing.tree.*;



public class saveReadGML extends JPanel
{
  JLabel filterLable ;
  JTextField filterText;
  JTextField hostText,portText;
  DefaultMutableTreeNode top,rootNode ;
  String rootDir,relativeRootDir;
  DefaultMutableTreeNode stack[] = new DefaultMutableTreeNode[16];
  int  s_top=0;
  static JFrame frame;
  Panel p;
  static String InitialRootDir="/usr/people/tom/QS";
  public static  GraphWindow gw;

  public void run(){}
  
  public saveReadGML (String InitialRootDir_,GraphWindow gw_) 
  {

    InitialRootDir = InitialRootDir_;
    FileTreeModel  root = new FileTreeModel(InitialRootDir,this);
    refreshFileBrowser(root ,InitialRootDir);
    gw = gw_;
  }

  public  SwingServletClient waitUntilSocketReady()
  {
    return gw.swingClient;
  }
 
 
public void refreshFileBrowser(FileTreeModel  root,String rootName)
  {
    
    //remove all the components inside the Panel
    removeAll();
    
    GridBagLayout gridbag = new GridBagLayout();
    GridBagConstraints c = new GridBagConstraints();
    setFont(new Font("Helvetica", Font.PLAIN, 14));
    setLayout(gridbag);

    selectedFile file_field = new selectedFile("",50,"file",this);
    
    DirTree tree = new DirTree(root,this);
    JScrollPane scrollPane = new JScrollPane(tree);
    tree.addMouseListener(file_field);
    tree.addTreeExpansionListener(root);
    root.addTreeModelListener(tree);
       
    c.fill = GridBagConstraints.HORIZONTAL;
    c.gridwidth = GridBagConstraints.REMAINDER;

     //Next row
    JLabel label = new JLabel("Enter Path and Folder Name :");
    gridbag.setConstraints(label, c);
    add(label);

    final selectedFile directory_field=new selectedFile(rootName,50,
					       	"directory",this);
    tree.addMouseListener(directory_field);
    directory_field.addActionListener(root);
    

    gridbag.setConstraints(directory_field, c);
    add(directory_field);

    c.fill = GridBagConstraints.BOTH;
    c.weightx = 1.0;
    c.weighty = 1.0;

    c.gridheight = 2;
    c.gridwidth = GridBagConstraints.REMAINDER;
    gridbag.setConstraints(scrollPane, c);
    add(scrollPane);

    //Next row
    c.weightx = 0.0;
    c.weighty = 0.0;
    c.fill = GridBagConstraints.HORIZONTAL;
    label = new JLabel("Enter File Name :");
    gridbag.setConstraints(label, c);
    add(label);

    gridbag.setConstraints(file_field, c);
    add(file_field);

    //Erol modifications
    directory_field.addActionListener(file_field);
    tree.addTreeExpansionListener(directory_field);
    tree.addTreeExpansionListener(file_field);
    //Erol

    c.fill = GridBagConstraints.NONE;

    //Next Row
    c.fill = GridBagConstraints.NONE;
    JButton  button = new JButton("Restore");
    c.gridwidth = GridBagConstraints.RELATIVE;
    gridbag.setConstraints(button, c);
    button.addActionListener(file_field);
    add(button);
       
    c.fill = GridBagConstraints.NONE;
    button = new JButton("Save");
    c.gridwidth = GridBagConstraints.RELATIVE;
    gridbag.setConstraints(button, c);
    button.addActionListener(file_field);
    add(button);
  }
  

  
     public static void main(String[] args) {
        /*
         * Create a window.  Use JFrame since this window will include 
         * lightweight components.
         */
        Panel panel;
       /*
        Frame frame = new Frame("TreeDemo");
       	frame.setLayout( new BorderLayout() );
        WindowListener l = new WindowAdapter() {
	   public void windowClosing(WindowEvent e) {System.exit(0);}
        };
        frame.addWindowListener(l);
		
        frame.add(BorderLayout.CENTER, new saveReadGML("444",8));
	frame.pack();
        //frame.move(60 + drawAreaSize.width, 10);frame.setSize(500, 500);
        frame.show(); */
    }
     
}


class selectedFile extends JTextField implements MouseListener,ActionListener,
TreeExpansionListener
{
public String name;
public String fullFilePath;
saveReadGML viewer;
  
public selectedFile(String text,int colums,String name_,saveReadGML viewer_)
  {
    super(text,colums);
    name = name_;
    addActionListener(this);
    viewer = viewer_;

    //Erol
    fullFilePath = viewer.InitialRootDir;
    //Erol
  }

public void treeExpanded(TreeExpansionEvent event)
  {
    System.out.println("treeExpanded is Called !!");
  
    TreePath selPath = event.getPath();
            
    String newDirName = DirTree.getSelectedItem(selPath);
    System.out.println("newDirName "+newDirName);
    if (name.equals("directory"))
      setText(newDirName);
    fullFilePath = newDirName;
    
    
  }

public void treeCollapsed(TreeExpansionEvent event)
  {
    System.out.println("treeCollapsed is Called !!");
  }

 //Erol modifications
public String getEntered()
  {
    String se = getText();
    String fe = fullFilePath;
    int pos   = fe.lastIndexOf(File.separator);
    if (pos > 0){
      fe  = fe.substring(0,pos)+File.separator;
      fe += se;
    }
    else{
      fe += File.separator+se;
    }
    return fe;
  }
   
 public void actionPerformed(ActionEvent e) {
   String command = e. getActionCommand();
   String entered = getEntered();

   /* Receive event from directory_field and update fullFilePath */
   Object source = e.getSource();
   if (source.getClass().getSuperclass() == this.getClass().getSuperclass()){
     fullFilePath = command;
     System.out.println("getting event from Directory");
     return;
   }

   String ac = e.getActionCommand() ;   
   if (name.equals("file")){
     System.out.println("File :"+entered+" are sent in ActionPerformed!!!"); 
     SwingServletClient socket = viewer.waitUntilSocketReady() ;
     socket.send("SWING_REPLY"+entered);
   }
   else if (ac.equals("Save")){  
       saveReadGML.gw.saveGMLInServer(entered);
   }
   else if (ac.equals("Restore")){
       saveReadGML.gw.getGMLfromServer(entered);
       // should add restoring BackEnd info!!!!

   }
  
 }
  
  

public void mouseClicked(MouseEvent e) {

  String dirName=null,fileName=null;
  
  System.out.println("inside  selectedFile!!!");
  Component source = e.getComponent();
  DirTree tree = (DirTree)source;
  
  int selRow = tree.getRowForLocation(e.getX(), e.getY());
  TreePath selPath = tree.getPathForLocation(e.getX(), e.getY());
      
  if (selPath != null){
    
    fullFilePath = tree.getSelectedItem(selPath);
    int index = fullFilePath.lastIndexOf(File.separator);
    fileName  = fullFilePath.substring(index+1);
    dirName   = fullFilePath.substring(0,index);
  
    if(selRow != -1) {
      if(e.getClickCount() == 1) {
	System.out.println("One Cliect pressed inside selectedfile !!!");
	if (name.equals("file"))
	  setText(fileName);
	else if (name.equals("directory"))
	  setText(dirName);
      }
      else if(e.getClickCount() == 2) {
	System.out.println("Two Cliect pressed inside selectedfile !!!");
	if (name.equals("file"))
	  setText(fileName);
	else if (name.equals("directory"))
	  setText(dirName);

	if ((fileName.length() > 0)&&(name.equals("file"))){
	  String entered = getEntered();
	  System.out.println("File :"+entered+" are sent!!!");
	  SwingServletClient socket = viewer.waitUntilSocketReady() ;
	  socket.send("SWING_REPLY"+entered);
	}
      }
    }
  }
  
}
  

 public void   mouseEntered(MouseEvent e) {;  }
     
 public void     mouseExited(MouseEvent e) {;  }
      
 public void     mousePressed(MouseEvent e) {;  }
      
 public void     mouseReleased(MouseEvent e) {;  }

  
}



class DirTree extends JTree implements MouseListener,TreeModelListener
{
  JLabel filterLable ;
  JTextField filterText;
  JTextField hostText,portText;
  public DefaultMutableTreeNode top,rootNode ;
  String rootDir,relativeRootDir;
  DefaultMutableTreeNode stack[] = new DefaultMutableTreeNode[16];
  int  s_top=0;
  static JFrame frame;
  Panel p;
  public saveReadGML viewer;
  DataInputStream dis;
  DataOutputStream dos;
  
  
 public DirTree(DefaultTreeModel  root,saveReadGML viewer_)
  {
    super(root);
    addMouseListener(this);
    viewer = viewer_;
  }

    


  public void mouseClicked(MouseEvent e) {

    System.out.println("inside DIRTREE !!!");
    Component source = e.getComponent();
    DirTree tree = (DirTree)source;
  
    int selRow = tree.getRowForLocation(e.getX(), e.getY());
    TreePath selPath = tree.getPathForLocation(e.getX(), e.getY());
    if(selRow != -1) {
      if(e.getClickCount() == 1) {
	System.out.println("One Cliect pressed inside DIRTREE !!!");
	//mySingleClick(selRow, selPath);
      }
      else if(e.getClickCount() == 2) {
	System.out.println("Two Cliect pressed inside DIRTREE !!!");
	fireTreeExpanded(selPath);
      }
    }
  
  }
public static String getSelectedItem(TreePath selPath)
  {
    int pcount = selPath.getPathCount();
    Object pathComponent =  selPath.getPathComponent(pcount-1);
    
   
    String fullPath="";
    for(int i=0;i<pcount;i++){
      TreeNode tn = (TreeNode)(selPath.getPathComponent(i));
      Object o = ((DefaultMutableTreeNode)tn).getUserObject();
      TreeNodeInfo tinfo = (TreeNodeInfo)o;

      String append = "";
      if ((tinfo.isDir())||((pcount>1)&&(i==0)))
	append = File.separator;
      fullPath += tinfo.toString()+append;
    }
    
    return fullPath;
  }

 public void   mouseEntered(MouseEvent e) {;  }
     
 public void     mouseExited(MouseEvent e) {;  }
      
 public void     mousePressed(MouseEvent e) {;  }
      
 public void     mouseReleased(MouseEvent e) {;  }
 

public void   treeNodesChanged(TreeModelEvent e)
  {
    System.out.println("treeNodesChanged is CALLED !!! ");
    
  }
  

 public void    treeNodesInserted(TreeModelEvent e) 
{
    System.out.println(" treeNodesInserted  is CALLED !!! ");
    
  }
 public void    treeNodesRemoved(TreeModelEvent e) 
{
    System.out.println("treeNodesRemoved  is CALLED !!! ");
    
  }

 public void    treeStructureChanged(TreeModelEvent e)
 {
    System.out.println("treeStructureChanged  is CALLED !!! ");
    int row = getRowForPath(e.getTreePath());
    System.out.println("treeStructureChanged:row:"+row);
    //expandRow(row);
    
    
 }      
}

class FileTreeModel extends DefaultTreeModel implements  TreeExpansionListener,
ActionListener
{
  
  static saveReadGML viewer;
  DefaultMutableTreeNode root;
  
public FileTreeModel(String dirFullPath,saveReadGML viewer_)
  {
    super(constructTree(dirFullPath));
    viewer = viewer_;
    root   = (DefaultMutableTreeNode)(getRoot());
    
  }

  public void actionPerformed(ActionEvent e) {
      String dirname = e.getActionCommand();
      System.out.println("ActionListener: directory name: "+dirname);
      root.removeAllChildren();
      updateTree(dirname,root,dirname);
      System.out.println("After updateTree");
      reload();
      System.out.println("ActionListener:inside FileTreeModel");
   }

  public static DefaultMutableTreeNode constructTree(String dirFullPath)
    {
      String s;
      DefaultMutableTreeNode top=null,one=null;
      
      System.out.println("Filter :"+saveReadGML.InitialRootDir);
      if (dirFullPath.equals(saveReadGML.InitialRootDir)){
	TreeNodeInfo firstNodeInfo = new TreeNodeInfo(".");
	firstNodeInfo.setDir();
	top = new DefaultMutableTreeNode(firstNodeInfo);
        return top;
	
      }
        
	SwingServletClient socket = viewer.waitUntilSocketReady() ;
        socket.send("SWING_REQ"+dirFullPath);
	String pwd = socket.receive();

	TreeNodeInfo firstNodeInfo = new TreeNodeInfo(pwd);
	firstNodeInfo.setDir();
	top = new DefaultMutableTreeNode(firstNodeInfo);
	System.out.println("rootDir "+pwd);
        
	String str_nfiles = socket.receive();
	int    nfiles     = Integer.parseInt(str_nfiles);
	System.out.println("nfiles  "+nfiles);
	
	socket.receive(); // read string "total xxxx" 
	
	for(int i=1;i<nfiles;i++)
	  {
	    s = socket.receive();
	    System.out.println("file "+s);
	    TreeNodeInfo tn = new TreeNodeInfo(s);
            if (!((tn.filename.equals("."))||(tn.filename.equals(".."))))
	      {
		System.out.println("adding to TREE");
		
		top.add(one = new DefaultMutableTreeNode(tn));
		//if this is directory, add dummy content file inside
		if (tn.isDir()){
		  //String n = "drwxr-xr-x 3 globus g_globus  3072 Apr 12 09:59 ../";
		  TreeNodeInfo tn_new = new TreeNodeInfo(".");
		  tn_new.setDummyFileName();	
		  one.add(new DefaultMutableTreeNode(tn_new));
		}
	      }
	  }
       System.out.println("end of performe ");
       return top;
       
    }
  
  //Is directory containing only dummy file 
public boolean isDirDummy( DefaultMutableTreeNode lastComponent)
  {
     Object o = lastComponent.getUserObject();
     TreeNodeInfo parentInfo = (TreeNodeInfo)o;

     TreeNode removedOne = lastComponent.getChildAt(0); 
     o = ((DefaultMutableTreeNode)removedOne).getUserObject();
     TreeNodeInfo childInfo = (TreeNodeInfo)o;
     System.out.println("child="+childInfo.filename+"="+
		      "permission="+parentInfo.permission+"="+
		       "cnt="+lastComponent.getChildCount());
     

     if ((parentInfo.isDir())&&
         (lastComponent.getChildCount() == 1)&&
	 (childInfo.isDummyFileName())){
       System.out.println("it is Dummy Node");
       return true;
     }
     
     else{
       System.out.println("it is NOT Dummy Node");
       return false;
     }
     
  }

public static int  updateTree(String dirFullPath,DefaultMutableTreeNode top,
			     String lastNodeName)
    {
        String s;
        DefaultMutableTreeNode one=null;
        int childCnt=0;

        System.out.println("Filter :updateTree:"+dirFullPath);
        
	SwingServletClient socket = viewer.waitUntilSocketReady() ;
        socket.send("SWING_REQ"+dirFullPath);
	String pwd = socket.receive();

	TreeNodeInfo firstNodeInfo = new TreeNodeInfo(lastNodeName);
	firstNodeInfo.setDir();
	top.setUserObject(firstNodeInfo);
	System.out.println("rootDir "+pwd);
        
	String str_nfiles = socket.receive();
	int    nfiles     = Integer.parseInt(str_nfiles);
	System.out.println("nfiles  "+nfiles);
	
	socket.receive(); // read string "total xxxx" 
	
	for(int i=1;i<nfiles;i++)
	  {
	    s = socket.receive();
	    System.out.println("file "+s);
	    TreeNodeInfo tn = new TreeNodeInfo(s);
            if (!((tn.filename.equals("."))||(tn.filename.equals(".."))))
	      {
		System.out.println("adding to TREE");
		childCnt++;

		top.add(one = new DefaultMutableTreeNode(tn));
		//if this is directory, add dummy content file inside
		if (tn.isDir()){
		  //String n = "drwxr-xr-x 3 globus g_globus  3072 Apr 12 09:59 ../";
		  TreeNodeInfo tn_new = new TreeNodeInfo(".");
		  tn_new.setDummyFileName();
		  one.add(new DefaultMutableTreeNode(tn_new));
		}
	      }
	  }
       System.out.println("end of performe ");

       if (childCnt == 0){
	 //String n = "drwxr-xr-x 3 globus g_globus  3072 Apr 12 09:59 ../";
	 TreeNodeInfo tn_new = new TreeNodeInfo(".");
	 tn_new.setDummyFileName();
	 top.add(new DefaultMutableTreeNode(tn_new));
	 childCnt++;
	 
       }
       return childCnt;
    }


public void getSelectedDirContent(TreePath selPath)
  {
    DefaultMutableTreeNode lastComponent = (DefaultMutableTreeNode)
                                           selPath.getLastPathComponent();

    Object o = lastComponent.getUserObject();
    TreeNodeInfo tinfo = (TreeNodeInfo)o;
    TreeNode removedOne = lastComponent.getChildAt(0); 
    
    if (isDirDummy(lastComponent))
      {
	//Construct subtree
	String selectedDir = getSelectedItem(selPath);
	
	lastComponent.removeAllChildren();
	int childCnt = updateTree(selectedDir,lastComponent,tinfo.filename);
	
	//announce dummy child is removed
	int[] childIndices = new int[1];
	childIndices[0] = 0;
	TreeNode[] removedChildren = new TreeNode[1];
	removedChildren[0] = removedOne;
	nodesWereRemoved((TreeNode)lastComponent,childIndices,
			  removedChildren);

	//announce some children added to current node	
        childIndices = new int[childCnt];
	for(int i=0;i<childCnt;i++) childIndices[i] = i;
        nodesWereInserted((TreeNode)lastComponent,childIndices);

      }
  }
  
public String getSelectedItem(TreePath selPath)
  {
    int pcount = selPath.getPathCount();
    Object pathComponent =  selPath.getPathComponent(pcount-1);
    
   
    String fullPath="";
    for(int i=0;i<pcount;i++){
      TreeNode tn = (TreeNode)(selPath.getPathComponent(i));
      Object o = ((DefaultMutableTreeNode)tn).getUserObject();
      TreeNodeInfo tinfo = (TreeNodeInfo)o;
      System.out.println("fn ="+tinfo.filename+" perm="+tinfo.permission);
      
      String append = "";
      if ((tinfo.isDir())||((pcount>1)&&(i==0)))
	append = File.separator;
      fullPath += tinfo.toString()+append;
    }
    
    return fullPath;
  }

public void treeExpanded(TreeExpansionEvent event)
  {
    System.out.println("treeExpanded is Called !!");
  
    TreePath selPath = event.getPath();
    System.out.println("selPath "+selPath.toString());
    System.out.println("selPath count ="+selPath.getPathCount());
        
      String newDirName = getSelectedItem(selPath);
      System.out.println("newDirName "+newDirName);
      
      if (newDirName.lastIndexOf(File.separator) == newDirName.length() -1){
	getSelectedDirContent(selPath);
	System.out.println("Getting Ne directory contents: "+newDirName);
      }
    
  }

public void treeCollapsed(TreeExpansionEvent event)
  {
    System.out.println("treeCollapsed is Called !!");
  }


}

class TreeNodeInfo 
{
  String permission,ndirs,user,group,filesize,month,day,time,filename,year;
  int    nitems;
  String separator;
  String sysdepdir;
  
  public boolean isDir()
  {
	if (permission == null)
	   return false;

	if ((separator.equals("/"))&&(permission.equals(sysdepdir)))
	   return true;
      if ((separator.equals("\\"))&&(permission.equals(sysdepdir)))
	   return true;
      return false;
  }

  public void setDir()
  {
     permission = sysdepdir;
  } 

  public void setDummyFileName()
  {
	filename = ".."+separator;
      setDir();
  }

  public boolean isDummyFileName()
  {
     String dummyname = ".."+separator;
     if (filename.equals(dummyname))
	  return true;
     return false;
  }

  public TreeNodeInfo (String fileInfo)
  {
    //System.out.println("TreeNodeInfo with :"+fileInfo+"-");
       
    permission = null;
    separator = File.separator;
    if (separator.equals("/"))
	 sysdepdir = "drwxr-xr-x";     //Unix
    else if (separator.equals("\\"))
	 sysdepdir = "<DIR>";          //WIN/NT

    String tokens[] = new String[16];
    int i = 0;
    StringTokenizer st = new StringTokenizer(fileInfo," ",false);
    while(st.hasMoreTokens()){
      tokens[i] = st.nextToken();
      //System.out.println("next token-"+tokens[i]+"-");
      i++;
    }

    if(separator.equals("/")){   //UNIX
  	 permission = tokens[0];
   	 ndirs      = tokens[1];
   	 user       = tokens[2];
   	 group      = tokens[3];
   	 filesize   = tokens[4];
   	 month      = tokens[5];
   	 day        = tokens[6];
   	 time       = tokens[7]; 
   	 filename   = tokens[8];
   	 for(int j=9;j<i;j++)
    	  filename += " "+tokens[j];
    
    }
    else if (separator.equals("\\")){    //WIN/NT
       st = new StringTokenizer(tokens[0],"/",false);
	 try{
       	month    = (String)st.nextToken();
       	day      = (String)st.nextToken();
       	year     = (String)st.nextToken();

            time     = tokens[1];
            filesize = tokens[2];
	      filename = tokens[3];
 	      for(int j=4;j<i;j++)
    	  	   filename += " "+tokens[j];
            
	      if (tokens[2].equals(sysdepdir))
	        permission = tokens[2];
            else
	       permission = "    "; 
        }catch(NoSuchElementException e) { filename = tokens[0];permission = tokens[0];}
     }  

     nitems = i;
     if (i == 1){ // directory name
	  //System.out.println("One TOken :-"+tokens[0]+"-");
    	  filename   = tokens[0];
	  //remove any trailing separator char
	  if (filename.endsWith(separator)){
	    //System.out.println("One TOken :-"+tokens[0]+"-"+" remove trailing char ");
	    filename = filename.substring(0,filename.length()-1);
        }
     }
  }
  
  public String toString()
  {
    return filename;
  }
  
}

